///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Settings FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    var enable_db_drop = false;

    function NavToSubscriptionInfo()
    {
        var curr_screen = 1;
        
        // Show that an action is in process
        ShowAct();
        
        // Find the settings page
        for (var i=0; i<global_Settings_Pages.length; i++)
        {
            if (global_Settings_Pages[i] == "settings_sub")
            {
                curr_screen = i;
                break;
            }
        }
        
        // Update the local database so it will take us to the Subscription page when we navigate to "Settings"
        var strSql = 'UPDATE User_Info_DB SET last_settings_screen=' + curr_screen + ' WHERE 1;';
        open_database_and_execute(strSql, '');
        
        // Call "Settings" navigation after a short delay to allow time for the last_settings_screen change to take effect
        ShowAct();
        TransitionToSubscreen("settings_sub", "slide");
    }
    
    function navBetweenSettings(state, target_screen, param_1, param_2)
    {
        var strSql = '';
        var tx = param_1;
        var TARGET_EVENTS_3 = 3;
        var TARGET_SETTINGS_4 = 4;
        var TARGET_SUBSCRIBE_5 = 5;
        var TARGET_PREG_7 = 7;
        var TARGET_GROUPS_8 = 8;
        var TARGET_SETTINGS_PUSH_9 = 9;

        printDebug("State " + state + " of navBetweenSettings");
        switch(state)
        {
        case 1:
LogCall('e1');
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_NavBtSet_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_NavBtSet_1 = -1;
                                    navBetweenSettings(state+1, target_screen, tx, '');
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_NavBtSet_1 > 0)
                                    {
                                        global_db_ios_fail_NavBtSet_1 = global_db_ios_fail_NavBtSet_1 - 1;
                                        printDebug('iOS db.transaction failed NavBetweenSettings state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_NavBtSet_1));
                                        navBetweenSettings(state, target_screen, param_1, param_2);
                                    }
                                    else if (global_db_ios_fail_NavBtSet_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            // Set dynamic build content for loaded page
            setDynamicContentForAppInstance(global_Settings_Pages[target_screen]);
            showPushCnts();
            break;

        case 2:
LogCall('e2');
            var target_state = TARGET_EVENTS_3;

            // Determine appropriate string
            switch(target_screen)
            {
            case 0:     
                // App Settings Screen
                strSql = 'SELECT * FROM User_Info_DB;';
                target_state = TARGET_SETTINGS_4;
                break;
            case 1:
                // Events Settings Screen
                strSql = 'SELECT * FROM Event_Settings_DB;';
                target_state = TARGET_EVENTS_3;
                break;
            case 2:
                strSql = '';
                target_state = TARGET_SETTINGS_PUSH_9;
                break;
            case 3:
                // Subscription Settings Screen - No local database query is needed.  Just download from web by calling into that state
                strSql = '';
                target_state = -1;
                navBetweenSettings(TARGET_SUBSCRIBE_5, 0, '', '');
                break;
            case 4:
                // Pregnancy Setting Screen
                strSql = 'SELECT * FROM Preg_DB;';
                target_state = TARGET_PREG_7;
                break;
            case 5:
                // Message Group Settings
                strSql = 'SELECT * FROM Groups_DB;';
                target_state = TARGET_GROUPS_8;
                break;
            case 6:
            default:
                // About Settings Screen - No local database query is needed.  Uses static content
                document.getElementById('app_version_div').innerHTML = CURRENT_APP_VERSION;
                document.getElementById('app_info_resolution_div').innerHTML = $('body').width() + ' by ' + $('body').height();
                document.getElementById('app_info_scale_div').innerHTML = global_calculated_scale + '<br>' + global_app_ver_str;
                strSql = '';
                target_state = -1;
                break;
            }
            
            if (target_state > 0)
            {
                // Query values from local database. 
                if (strSql != '') 
                {
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        navBetweenSettings(target_state, target_screen, tx, results);
                                    },
                                    function(tx, err)
                                    {
                                        crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                    }
                                 );
                }
                else
                {
                    navBetweenSettings(target_state, target_screen, tx, results);
                }
             }
             else
             {
                HideAct();
             }
             HideAct_Legacy();
            break;
            
        case TARGET_EVENTS_3:     // EVENTS Screen
LogCall('e3');
            // Retrieve results of query
            var results = param_2;
            var cev_name = '';
            var encoded = new Array();
            var decoded = new Array();
            var checked_value = false;
            var i;
            
            // Determine which events should be visible
            for (i=1; i<=NUMBER_OF_EVENT_WORDS; i++)
            {
                // Get values from database
                encoded[i-1] = results.rows.item(0)['ev_show_word' + i];
            }
            // Convert from encoded to decoded values
            decoded = DecompressEventBits(encoded);
            // Loop through and initialize values as appropriate
            for (i=0; i<decoded.length; i++)
            {
                if (decoded[i] == 0)
                {
                    checked_value = false; 
                }
                else
                {
                    checked_value = true;
                }
                $("input[id='evShowCheckbox_" + i + "']").attr("checked", checked_value).checkboxradio("refresh");
            }
            // Load custom event names
            for (i=1; i<=NUMBER_OF_CUSTOM_EVENTS; i++)
            {
                cev_name = results.rows.item(0)['cev_name_' + i];
                document.getElementById('evShowCustomText' + i).value = cev_name;
            }
            HideAct();
            break;
            
        case TARGET_SETTINGS_4:     // APP SETTINGS Screen
LogCall('e4');
            var results = param_2;
            // Load Fields
            document.getElementById('app_settings_username_span').innerHTML = results.rows.item(0)['un'].toLowerCase();
            $("input[id='appSettings_ReqLogin']").attr("checked", convert_01_to_TF(results.rows.item(0)['pw_prompt'])).checkboxradio("refresh");
            $("input[id='appSettings_ShowTips']").attr("checked", convert_01_to_TF(results.rows.item(0)['tip_of_day_enabled'])).checkboxradio("refresh");
            var myselect = $("select#appSettings_DarkBkgnd");
			myselect[0].selectedIndex = results.rows.item(0)['dark_bkgnd'];
            myselect.selectmenu("refresh");
			$("input[id='appSettings_CathMode']").attr("checked", convert_01_to_TF(results.rows.item(0)['catholic'])).checkboxradio("refresh");
            $("input[id='appSettings_EnabRemote']").attr("checked", convert_01_to_TF(results.rows.item(0)['enable_remote_analysis'])).checkboxradio("refresh");
            $("input[id='appSettings_EnDebug']").attr("checked", convert_01_to_TF(results.rows.item(0)['debug'])).checkboxradio("refresh");
            $("input[id='appSettings_CalShade']").attr("checked", convert_01_to_TF(results.rows.item(0)['cal_shade'])).checkboxradio("refresh");
            $("input[id='appSettings_CalOv']").attr("checked", convert_01_to_TF(results.rows.item(0)['cal_ov'])).checkboxradio("refresh");
            switch(results.rows.item(0)['t_units'])
            {
            case 'F':
            default:
                $("input[id='appSettings_tUnitsRadio_C']").attr("checked",false).checkboxradio("refresh");
                $("input[id='appSettings_tUnitsRadio_F']").attr("checked",true).checkboxradio("refresh");
                break;
            case 'C':
                $("input[id='appSettings_tUnitsRadio_C']").attr("checked",true).checkboxradio("refresh");
                $("input[id='appSettings_tUnitsRadio_F']").attr("checked",false).checkboxradio("refresh");
                break;
            }
            switch(results.rows.item(0)['sync_interval'])
            {
            case 60:
                $("input[id='appSettings_RemSync_1m']").attr("checked",true).checkboxradio("refresh");
                break;
            case 180:
            default:
                $("input[id='appSettings_RemSync_3m']").attr("checked",true).checkboxradio("refresh");
                break;
            case 300:
                $("input[id='appSettings_RemSync_5m']").attr("checked",true).checkboxradio("refresh");
                break;
            case 600:
                $("input[id='appSettings_RemSync_10m']").attr("checked",true).checkboxradio("refresh");
                break;
            }
            HideAct();
            break;
            
        case TARGET_SUBSCRIBE_5:     // SUBSCRIPTION Screen
LogCall('e5');
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            var url_str = global_server_prefix + 'apps_get_data.aspx?t=' + getLocalTime();
            
            // Display username
            document.getElementById('app_account_un_span').innerHTML = global_username.toLowerCase();
            document.getElementById('sub_bottom_webad').innerHTML = document.getElementById('sub_top_webad').innerHTML;
            
            // Validate the password with the online version.  Specify values to upload
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['subhist'] = '1';
            uploadParameters['debug'] = global_Debug_Enabled;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;

            // Use jQuery to post data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) {
                    // Handles response this function and advance to the next state.  Notice that the tx
                    // cannot be passed to this legitimately because it is not being created as a call
                    // to this registered function (it only has a newContent argument) because this 
                    // callback has nothing to do with databases.  Therefore we will have to re-establish
                    // the tx variable when we want to resume database operations.
                    navBetweenSettings(state+1, target_screen, newContent, '');
                },
                dataType: 'html'
            });  
            break;
            
        case 6:
LogCall('e6');
            var newContent = param_1;
            var offset;

            var new_pw = param_2;
            var c_LOGIN_OK = 0;
            var c_NUMBER_OF_ORDERS = 1;
            var c_PAY_URL = 2;
            var c_NO_SUB = 3;
            var c_FULL_SUB = 4;
            var c_SUB_EXP_DATE = 5;
            var c_PAY_OPT_DESC_BASE = 6;    // uses 6-8
            var c_PAY_OPT_URL_BASE = 7;     // uses 9-11
            var c_PAY_HISTORY_BASE = 12;     // uses 12 onward in groups of 4 (e.g. 12-15, etc)

            var desiredStrStart=new Array();        // Start delimeter to look for in server response
            var desiredStrEnd=new Array();          // End delimeter to look for in server response
            var respParamsStr=new Array();          // Placeholder for the parsed response found in the server returned content.
            
            desiredStrStart[c_LOGIN_OK]="LOGIN_OK";
            desiredStrEnd[c_LOGIN_OK]="";
            
            desiredStrStart[c_NUMBER_OF_ORDERS]="NUM_ORDERS=";
            desiredStrEnd[c_NUMBER_OF_ORDERS]=" ";
            
            // Do a preliminary parse to find how many orders we need to look up
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Setup to extract payment info fields
            desiredStrStart[c_NO_SUB]="NO_SUB";
            desiredStrEnd[c_NO_SUB]="";
            desiredStrStart[c_FULL_SUB]="FULL_SUB";
            desiredStrEnd[c_FULL_SUB]="";          
            desiredStrStart[c_SUB_EXP_DATE]="SUB_EXP=";
            desiredStrEnd[c_SUB_EXP_DATE]=" "; 

            desiredStrStart[c_PAY_URL]="PAY_URL=";
            desiredStrEnd[c_PAY_URL]=" "; 
            for (var i=1; i<=3; i++)
            {
                offset = (i-1)*2;
                desiredStrStart[c_PAY_OPT_DESC_BASE + offset]="PAY_OPT" + i + "_DESC=";
                desiredStrEnd[c_PAY_OPT_DESC_BASE + offset]="@!@";
                
                desiredStrStart[c_PAY_OPT_URL_BASE + offset]="PAY_OPT" + i + "_URL=";
                desiredStrEnd[c_PAY_OPT_URL_BASE + offset]="@!@";                
            }

            // Loop through and extract the payment history or arbitrary length
            for (var i=1; i<=respParamsStr[c_NUMBER_OF_ORDERS]; i++)
            {
                offset = (i-1)*4; 
                
                desiredStrStart[c_PAY_HISTORY_BASE + 0 + offset]="PAY_DATE_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 0 + offset]=" ";
                
                desiredStrStart[c_PAY_HISTORY_BASE + 1 + offset]="ORDER_ID_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 1 + offset]=" ";

                desiredStrStart[c_PAY_HISTORY_BASE + 2 + offset]="AMOUNT_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 2 + offset]=" ";      

                desiredStrStart[c_PAY_HISTORY_BASE + 3 + offset]="NEW_EXP_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 3 + offset]=" "; 
            }

            // Re-Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Check the sought parameters
            if (respParamsStr[c_LOGIN_OK] == '1')
            {
                // Load subscription status
                document.getElementById('settingsSubStatus').innerHTML = trans_dyn_content("Unknown - Could not check status");
                if (respParamsStr[c_NO_SUB] == 1)
                {
                    document.getElementById('settingsSubStatus').innerHTML = trans_dyn_content("Subscription is Expired<br>Expired on: ") + respParamsStr[c_SUB_EXP_DATE];
                }
                if (respParamsStr[c_FULL_SUB] == 1)
                {
                    document.getElementById('settingsSubStatus').innerHTML = trans_dyn_content("Subscription is Active<br>Active through: ") + respParamsStr[c_SUB_EXP_DATE];
                }
				if (global_username.toLowerCase() == ("sync" + "low"))
				{
					document.getElementById('settingsSubStatusLink').innerHTML = '';
				} 
				else if (global_is_ios)
				{
					document.getElementById('settingsSubStatusLink').innerHTML = '<a href="' + respParamsStr[c_PAY_URL] + '" target="_blank" onclick="return go2url(this);">' + trans_dyn_content("Manage Account") + '</a>';
                }
				else
				{
					document.getElementById('settingsSubStatusLink').innerHTML = '<a href="' + respParamsStr[c_PAY_URL] + '" target="_blank" onclick="return go2url(this);">' + trans_dyn_content("Manage Subscriptions") + '</a>';
				}
				for (var i=1; i<=3; i++)
                {
                    offset = (i-1)*2;
                    document.getElementById('settingsOptionDesc_' + i).innerHTML = respParamsStr[c_PAY_OPT_DESC_BASE + offset];
                    document.getElementById('settingsOptionURL_' + i).innerHTML = respParamsStr[c_PAY_OPT_URL_BASE + offset];
                }
                var historyStr = '';
                for (var i=respParamsStr[c_NUMBER_OF_ORDERS]; i>0; i--)
                {
                    offset = (i-1)*4; 
                    
                    historyStr += "<u>" + trans_dyn_content("Payment") + " #" + i + "</u><br>";
                    historyStr += trans_dyn_content("Paid") + ": " + respParamsStr[c_PAY_HISTORY_BASE + 2 + offset];
                    historyStr += trans_dyn_content(" on ") + respParamsStr[c_PAY_HISTORY_BASE + 0 + offset];
                    historyStr += "<BR>";
                    historyStr += trans_dyn_content("Order") + " #" + respParamsStr[c_PAY_HISTORY_BASE + 1 + offset];
                    historyStr += ".  " + trans_dyn_content("Expires on") + " " + respParamsStr[c_PAY_HISTORY_BASE + 3 + offset] + '<BR><BR>';
                }
                document.getElementById('settingsPayHistoryDiv').innerHTML = historyStr;
            }
            HideAct();
            break;
           
        case TARGET_PREG_7:     // Pregnancy Screen
LogCall('e7');
            // Retrieve results of query
            var results = param_2;
            var len = results.rows.length;
            var record_date_val;
            var record_date_str;
            var preg_len;
            var i;
            
            // Get drop down control control for preg picker
            var optionsList;
            var cycleSelect = $('#Settings_PregPickerSelect');
            if(cycleSelect.prop) 
            {
                optionsList = cycleSelect.prop('options');
            }
            else 
            {
                optionsList = cycleSelect.attr('options');
            }
            
            // Clear list
            $('option', cycleSelect).remove();
            
            // Load content
            if (len == 0)
            {
                optionsList[optionsList.length] = new Option(trans_dyn_content("No pregnancies recorded yet"), 0);
                document.getElementById('Settings_PregHistory').innerHTML = trans_dyn_content("You have not recorded any previous pregnancies.");
            }
            else
            {
                optionsList[optionsList.length] = new Option(trans_dyn_content("Please select a pregnancy"), 0);           
                document.getElementById('Settings_PregHistory').innerHTML = '';
                
                // Loop through results and populate pregs
                for (var i=0; i<len; i++)
                {
                    record_date_val = results.rows.item(i)['preg_started'];
                    record_date_str = PrintDate(NumberToDate(record_date_val));
                    preg_len = results.rows.item(i)['preg_len'];
                    if (preg_len > 0)
                    {
                        optionsList[optionsList.length] = new Option(record_date_str, record_date_val);
                        document.getElementById('Settings_PregHistory').innerHTML += '<u>' + trans_dyn_content("Pregnancy ") + (i+1) + '</u>:<br>' + trans_dyn_content("Started:") + '<b> ' + record_date_str + '</b><br>' + trans_dyn_content("Duration:") + ' <b>' + (preg_len+13) + trans_dyn_content(" days") + '</b><br>' + trans_dyn_content("Type:") + ' <b>' + ConvertPregOutcome(results.rows.item(i)['preg_status'],false,false,true,false) + '</b><br>' + trans_dyn_content("End Date:") + ' <b>' + PrintDate(NumberToDate(record_date_val+preg_len-1)) + '</b><br><br>';
                    }
                    else
                    {
                        printDebug('DELETED PREG ' + record_date_val + ' IGNORED');
                    }
                }
                document.getElementById('Settings_PregHistory').innerHTML += '</ul>';
            }
            
            // Refresh control after update and make a default selection
            cycleSelect[0].selectedIndex = 0;
            cycleSelect.selectmenu("refresh");
            
            HideAct();
            break;
           
        case TARGET_GROUPS_8:     // Message Group Screen
LogCall('e8');
            // Retrieve results of query
            var results = param_2;
            var len = results.rows.length;
            var i;
            
            // Get controls
            var groupList;
            var groupSelect = $('#Settings_GroupsSelect');
            if(groupSelect.prop) 
            {
                groupList = groupSelect.prop('options');
            }
            else 
            {
                groupList = groupSelect.attr('options');
            }
            var contactList;
            var contactSelect = $('#Settings_ContactSelect');
            if(contactSelect.prop) 
            {
                contactList = contactSelect.prop('options');
            }
            else 
            {
                contactList = contactSelect.attr('options');
            }
            
            // Clear lists
            $('option', groupSelect).remove();
            $('option', contactSelect).remove();
            
            // Load content
            var uCnt = 0;
            var gCnt = 0;
            if (len == 0)
            {
                groupList[groupList.length] = new Option(trans_dyn_content("No hashtags defined"), 0);
                contactList[contactList.length] = new Option(trans_dyn_content("No contacts defined"), 0);
            }
            else
            {
                // Loop through results and populate
                for (var i=0; i<len; i++)
                {
                    var gCode = results.rows.item(i)['gcode'];
                    if (gCode.charAt(0) == '@')
                    {
                        if (uCnt == 0)
                        {
                            contactList[contactList.length] = new Option(trans_dyn_content("Please select a contact"), 0);
                        }
                        uCnt += 1;
                        var code_desc = results.rows.item(i)['desc'] + ' (' + gCode.substring(1,gCode.length) + ')';
                        var db_id = results.rows.item(i)['id'];
                        contactList[contactList.length] = new Option(code_desc, db_id);  
                    }
                    else
                    {
                        if (gCnt == 0)
                        {
                            groupList[groupList.length] = new Option(trans_dyn_content("Please select a hashtag"), 0);
                        }
                        gCnt += 1;
                        var code_desc = results.rows.item(i)['desc'] + ' (#' + gCode + ')';
                        var db_id = results.rows.item(i)['id'];
                        groupList[groupList.length] = new Option(code_desc, db_id);
                    }
                }
                if (gCnt == 0)
                {
                    groupList[groupList.length] = new Option(trans_dyn_content("No hashtags defined"), 0);
                }
                if (uCnt == 0)
                {
                    contactList[contactList.length] = new Option(trans_dyn_content("No contacts defined"), 0);
                }
            }
            
            // Refresh control after update and make a default selection
            groupSelect[0].selectedIndex = 0;
            groupSelect.selectmenu("refresh");
            contactSelect[0].selectedIndex = 0;
            contactSelect.selectmenu("refresh");
            
            HideAct();
            break;
           
        case TARGET_SETTINGS_PUSH_9:     // Push Notifications
           
            // Query Push Notification Settings from Server
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            var url_str = global_server_prefix + 'apps_get_data.aspx?t=' + getLocalTime();
            
            // Validate the password with the online version.  Specify values to upload
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['push_cfg'] = '1';
            uploadParameters['debug'] = global_Debug_Enabled;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;

            // Use jQuery to post data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) {
                    // Handles response this function and advance to the next state.  Notice that the tx
                    // cannot be passed to this legitimately because it is not being created as a call
                    // to this registered function (it only has a newContent argument) because this 
                    // callback has nothing to do with databases.  Therefore we will have to re-establish
                    // the tx variable when we want to resume database operations.
                    navBetweenSettings(TARGET_SETTINGS_PUSH_9+1, target_screen, newContent, '');
                },
                dataType: 'html'
            });  
            break;
            
        case TARGET_SETTINGS_PUSH_9+1:
         
            var newContent = param_1;
            var offset;

            var new_pw = param_2;
            var c_LOGIN_OK = 0;
            var c_PUSH_ROLE = 1;
            var c_PUSH_PH_EN = 2;
            var c_PUSH_TTL_EN = 3;
            var c_PUSH_TTL_MSG = 4;
            var c_PUSH_CYC_EN = 5;
            var c_PUSH_OV_EN = 6;
            var c_PUSH_ALM_EN = 7; 
            var c_PUSH_ALM_TIME = 8;
            var c_PUSH_FORG_EN = 9;
            var c_PUSH_FORG_TIME = 10;
            var c_PUSH_POST_PRIV = 11;
            var c_PUSH_POST_MINE = 12;
            var c_PUSH_POST_RESP = 13;
            var c_PUSH_WAT_STUDS = 14;
            var c_IS_INSTRUCTOR = 15;
            var c_PUSH_HISTORY = 16;
            var c_TIME_ZONE_CHG = 17;

            var desiredStrStart=new Array();        // Start delimeter to look for in server response
            var desiredStrEnd=new Array();          // End delimeter to look for in server response
            var respParamsStr=new Array();          // Placeholder for the parsed response found in the server returned content.
            
            desiredStrStart[c_LOGIN_OK]="LOGIN_OK";
            desiredStrEnd[c_LOGIN_OK]="";
            
            // Setup to extract push settings
            desiredStrStart[c_PUSH_ROLE]="PUSH_ROLE=";
            desiredStrEnd[c_PUSH_ROLE]=" ";
            desiredStrStart[c_PUSH_PH_EN]="PUSH_PH_EN=";
            desiredStrEnd[c_PUSH_PH_EN]=" ";
            desiredStrStart[c_PUSH_TTL_EN]="PUSH_TTC_EN=";
            desiredStrEnd[c_PUSH_TTL_EN]=" ";
            desiredStrStart[c_PUSH_TTL_MSG]="PUSH_TTC_MSG=";
            desiredStrEnd[c_PUSH_TTL_MSG]="@!@.";
            desiredStrStart[c_PUSH_CYC_EN]="PUSH_CYC_EN=";
            desiredStrEnd[c_PUSH_CYC_EN]=" ";
            desiredStrStart[c_PUSH_OV_EN]="PUSH_OV_EN=";
            desiredStrEnd[c_PUSH_OV_EN]=" ";          
            desiredStrStart[c_PUSH_ALM_EN]="PUSH_ALM_EN=";
            desiredStrEnd[c_PUSH_ALM_EN]=" ";
            desiredStrStart[c_PUSH_ALM_TIME]="PUSH_ALM_TIME=";
            desiredStrEnd[c_PUSH_ALM_TIME]="@!@.";
            desiredStrStart[c_PUSH_FORG_EN]="PUSH_FORG_EN=";
            desiredStrEnd[c_PUSH_FORG_EN]=" ";
            desiredStrStart[c_PUSH_FORG_TIME]="PUSH_FORG_TIME=";
            desiredStrEnd[c_PUSH_FORG_TIME]="@!@.";
            desiredStrStart[c_PUSH_POST_PRIV]="PUSH_POST_PRIV=";
            desiredStrEnd[c_PUSH_POST_PRIV]=" ";
            desiredStrStart[c_PUSH_POST_MINE]="PUSH_POST_MINE=";
            desiredStrEnd[c_PUSH_POST_MINE]=" ";
            desiredStrStart[c_PUSH_POST_RESP]="PUSH_POST_RESP=";
            desiredStrEnd[c_PUSH_POST_RESP]=" ";
            desiredStrStart[c_PUSH_WAT_STUDS]="PUSH_WAT_STUDS=";
            desiredStrEnd[c_PUSH_WAT_STUDS]=" ";
            desiredStrStart[c_IS_INSTRUCTOR]="IS_INSTR=";
            desiredStrEnd[c_IS_INSTRUCTOR]=" ";
            desiredStrStart[c_PUSH_HISTORY]="PUSH_HISTORY=";
            desiredStrEnd[c_PUSH_HISTORY]="@!@.";               
            desiredStrStart[c_TIME_ZONE_CHG]="TIME_ZONE_CHG=";
            desiredStrEnd[c_TIME_ZONE_CHG]=" ";
         

            // Re-Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

            // Check the sought parameters
            if (respParamsStr[c_LOGIN_OK] == '1')
            {
                if (respParamsStr[c_PUSH_HISTORY] == '')
                {
                    document.getElementById('pastNotDiv').innerHTML = 'None';
                }
                else
                {
                    document.getElementById('pastNotDiv').innerHTML = respParamsStr[c_PUSH_HISTORY];
                }
                if (respParamsStr[c_TIME_ZONE_CHG] == '1')
                {
                    document.getElementById('settingsTimeZoneSync').innerHTML = 'The time zone of your device was just corrected on the server.<br>&nbsp;<br>';
                }
                else
                {
                    document.getElementById('settingsTimeZoneSync').innerHTML = '';
                }
                if (respParamsStr[c_PUSH_ROLE] == 'M')
                {
                    $("input[id='appSettings_Role_F']").attr("checked",false).checkboxradio("refresh");
                    $("input[id='appSettings_Role_M']").attr("checked",true).checkboxradio("refresh");
                }
                else
                {
                    $("input[id='appSettings_Role_M']").attr("checked",false).checkboxradio("refresh");
                    $("input[id='appSettings_Role_F']").attr("checked",true).checkboxradio("refresh");
                }
                $("input[id='appSettings_PushAlarm']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_ALM_EN])).checkboxradio("refresh");
                document.getElementById('appSettings_PushAlarmTime').value = respParamsStr[c_PUSH_ALM_TIME];
                $("input[id='appSettings_PushForget']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_FORG_EN])).checkboxradio("refresh");
                document.getElementById('appSettings_PushForgetTime').value = respParamsStr[c_PUSH_FORG_TIME];
                $("input[id='appSettings_PushCyc']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_CYC_EN])).checkboxradio("refresh");
                $("input[id='appSettings_PushPhase']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_PH_EN])).checkboxradio("refresh");
                $("input[id='appSettings_PushOv']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_OV_EN])).checkboxradio("refresh");
                $("input[id='appSettings_PushTTC']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_TTL_EN])).checkboxradio("refresh");
                document.getElementById('appSettings_PushTTCMsg').value = respParamsStr[c_PUSH_TTL_MSG];
                $("input[id='appSettings_PushPrivMsg']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_POST_PRIV])).checkboxradio("refresh");
                $("input[id='appSettings_PushMyPost']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_POST_MINE])).checkboxradio("refresh");
                $("input[id='appSettings_PushAnyPost']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_POST_RESP])).checkboxradio("refresh");
                $("input[id='appSettings_PushStudents']").attr("checked", convert_01_to_TF(respParamsStr[c_PUSH_WAT_STUDS])).checkboxradio("refresh");
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    document.getElementById('notify_of_ovs').style.display = 'none';
                }
                else
                {
                    document.getElementById('notify_of_phase').style.display = 'none';
                }
                if (respParamsStr[c_IS_INSTRUCTOR] == 1)
                {
                    document.getElementById('push_instr_on').style.display = 'block';
                }
                else
                {
                    document.getElementById('push_instr_on').style.display = 'none';
                }
            }
            else
            {
                printDebug('login problem');
            }
            HideAct();
            break;
            
        default:
            break;
        }
        return;
    }
    
    function switchDispShowCategory(which_suffix)
    {
        var NUMBER_OF_CATEGORIES = 6;
        
        // First hide all of them
        for (var i=1; i<=NUMBER_OF_CATEGORIES; i++)
        {
            document.getElementById('divEvShow_' + i).style.display = 'none';
        }
        
        // Then display only this selected one
        document.getElementById('divEvShow_' + which_suffix).style.display = 'block';
        
        return;
    }
    function applyClassAct(state, param_1, param_2)
	{
        printDebug("State " + state + " of applyClassAct");
        switch(state)
        {
        case 1:
			// Validate input
			var class_code = ReplaceQuotes(document.getElementById('appSettings_ClassAct').value, 1);
			var lang_code = '';
			var other_code = '';
			if (class_code.toLowerCase().indexOf("ciclos") >= 0)
			{
				lang_code = 99;
			}
			else if (class_code.toLowerCase().indexOf("clase") >= 0)
			{
				lang_code = class_code.toLowerCase().replace("clase","");
				lang_code = parseInt(lang_code);
				if (isNaN(lang_code))
				{
					lang_code = '';
				}
			}
			else if (class_code.indexOf("set") >= 0)
			{
				other_code = class_code; 
			}
			// Send to remote server
			if ((lang_code == '') && (other_code == '') && (lang_code != 0))
			{
				ShowPopupMessage(trans_dyn_content("You must enter a valid classroom code given to you by your instructor. Do not use this feature unless specifically instructed by CCL."), trans_dyn_content("Missing Code"), '');
			}
			else
			{
                var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
				var url_str = global_server_prefix + 'apps_set_data.aspx?t=' + getLocalTime();
                
                // Validate the password with the online version.  Specify values to upload
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = global_password;
                uploadParameters['lang_code'] = lang_code;
				uploadParameters['other_code'] = other_code;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;

                // Use jQuery to post data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        applyClassAct(state+1, newContent, class_code);
                    },
                    dataType: 'html'
                });
			}       
            break;
            
        case 2:
            var newContent = param_1;
            var c_LOGIN_OK = 0;
            var c_LANG_CHANGE = 1;
            var c_OTHER_ACT = 2;
            var c_LOGIN_INVALID = 3;

            var desiredStrStart=new Array();        // Start delimeter to look for in server response
            var desiredStrEnd=new Array();          // End delimeter to look for in server response
            var respParamsStr=new Array();          // Placeholder for the parsed response found in the server returned content.
            
            desiredStrStart[c_LOGIN_OK]="LOGIN_OK";
            desiredStrEnd[c_LOGIN_OK]="";
            
            desiredStrStart[c_LANG_CHANGE]="LANG_CHG=";
            desiredStrEnd[c_LANG_CHANGE]=" ";
            
            desiredStrStart[c_OTHER_ACT]="OTHER_ACT=";
            desiredStrEnd[c_OTHER_ACT]=" ";
            
            desiredStrStart[c_LOGIN_INVALID]="LOGIN_INVALID";
            desiredStrEnd[c_LOGIN_INVALID]="";

            // Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Check the sought parameters
            if (respParamsStr[c_LOGIN_OK] == '1')
            {
                if (respParamsStr[c_LANG_CHANGE] != '')
                {
                    // Success - update local database
					global_spanish = parseInt(respParamsStr[c_LANG_CHANGE]);
                    strSql = 'UPDATE User_Info_DB SET spanish="' + global_spanish + '" WHERE 1;';
                    open_database_and_execute(strSql, '');
                    
                    // Update status
                    ShowPopupMessage(trans_dyn_content("The server successfully processed the classroom code. "), trans_dyn_content("Success"), '');
                    break;
                }
                else if (respParamsStr[c_OTHER_ACT] != '')
                {
					// Future use
                    ShowPopupMessage(trans_dyn_content("The server successfully processed the classroom code. ") + respParamsStr[c_OTHER_ACT], trans_dyn_content("Success"), '');
                    break;
                }
                else 
                {
					ShowPopupMessage(trans_dyn_content("The server did not recognize or accept the classroom code provided."), trans_dyn_content("Error"), '');
				}
            }
            break;
        
        default:
            break;
        }
        return;
	}
    function changeUsername()
    {
LogCall('1c');
        // Prompt user with warnings and then drop all tables and restart app.  May not be necessary
        // if uninstalling the app also effectively drops the tables.
        if (enable_db_drop == true)
        {
            drop_databases();
            setTimeout("ClosePopupMessage();startup_app_navigation();",3500);
            g_LoadTimestamps = {};
            ShowPopupMessage("Your app has been reset.  You can now associate it with another account.  The app will restart in 3 seconds.", 'App Reset', '');
        }
        else
        {
            ShowPopupMessage("WARNING: This will delete all data on your device.  To change username, you must reset this app and delete all data stored within it.  Make sure you have synchronized with the remote server first if you want to preserve any data.  If you really want to delete all data and reset the app so you can associate with another account, press this same button again within 10 seconds of the first time you pushed it.", 'WARNING', '');
            setTimeout("changeUsernameTimeUp();",10000);
            $('#ChangeUsernameButton').parent().find('.ui-btn-text').text('Proceed to DELETE My App Data!');
            enable_db_drop = true;
        }
        return;
    }
    function changeUsernameTimeUp()
    {
        enable_db_drop=false;
        if (GetCurrentPage() == 'settings_app')
        {
            document.getElementById('ChangeUsernameButton').value = '';
            $('#ChangeUsernameButton').parent().find('.ui-btn-text').text('Change Account');
        }
    }
    
    function tryToChangePw(state, param_1, param_2)
    {
LogCall('1d');
        printDebug("State " + state + " of tryToChangePw");
        switch(state)
        {
        case 1:
            // Check if they have successfully entered enough information to change the password
            if (document.getElementById('appSettings_CurrPwTextbox').value == '')
            {
                // Apparently they are not trying to change the password
                document.getElementById('appSettings_PwChgStatus').innerHTML = '';
            }
            else if (document.getElementById('appSettings_NewPwTextbox').value == '')
            {
                // Apparently they are not trying to change the password
                document.getElementById('appSettings_PwChgStatus').innerHTML = '';
            }
            else if (document.getElementById('appSettings_NewPwTextbox').value != document.getElementById('appSettings_ConfirmPwTextbox').value)
            {
                // They must not be trying to change the password
                document.getElementById('appSettings_PwChgStatus').innerHTML = 'Passwords Do Not Match';
            }
            else
            {
                // Validate the password with the online version.  It will accept and change the password if the old or new
                // password they type in matches the current password associated with their web account
                var new_pw = ReplaceQuotes(document.getElementById('appSettings_NewPwTextbox').value, 1);
                var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
                var url_str = global_server_prefix + 'apps_set_data.aspx?t=' + getLocalTime();
                
                // Validate the password with the online version.  Specify values to upload
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = ReplaceQuotes(document.getElementById('appSettings_CurrPwTextbox').value, 1);
                uploadParameters['chgd_pw'] = new_pw;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;

                // Use jQuery to post data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        tryToChangePw(state+1, newContent, new_pw);
                    },
                    dataType: 'html'
                });
            }           
            break;
            
        case 2:
            var newContent = param_1;
            var new_pw = param_2;
            var c_LOGIN_OK = 0;
            var c_PW_CHG = 1;
            var c_PW_RESET = 2;
            var c_LOGIN_INVALID = 3;

            var desiredStrStart=new Array();        // Start delimeter to look for in server response
            var desiredStrEnd=new Array();          // End delimeter to look for in server response
            var respParamsStr=new Array();          // Placeholder for the parsed response found in the server returned content.
            
            desiredStrStart[c_LOGIN_OK]="LOGIN_OK";
            desiredStrEnd[c_LOGIN_OK]="";
            
            desiredStrStart[c_PW_CHG]="PW_CHANGED";
            desiredStrEnd[c_PW_CHG]="";
            
            desiredStrStart[c_PW_RESET]="PW_RESET";
            desiredStrEnd[c_PW_RESET]="";
            
            desiredStrStart[c_LOGIN_INVALID]="LOGIN_INVALID";
            desiredStrEnd[c_LOGIN_INVALID]="";

            // Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Check the sought parameters
            if (respParamsStr[c_LOGIN_OK] == '1')
            {
                if (respParamsStr[c_PW_CHG] == '1')
                {
                    // Success - update local database
                    strSql = 'UPDATE User_Info_DB SET pw="' + new_pw + '" WHERE 1;';
                    open_database_and_execute(strSql, '');
                    
                    // Update status
                    document.getElementById('appSettings_CurrPwTextbox').value = '';
                    document.getElementById('appSettings_NewPwTextbox').value = '';
                    document.getElementById('appSettings_ConfirmPwTextbox').value = '';
                    document.getElementById('appSettings_PwChgStatus').innerHTML = trans_dyn_content("Password Changed");
                    
                    break;
                }
                else if (respParamsStr[c_PW_RESET] == '1')
                {
                    // Error because password was reset due to too many failed attempts
                    document.getElementById('appSettings_CurrPwTextbox').value = '';
                    document.getElementById('appSettings_PwChgStatus').innerHTML = trans_dyn_content("Incorrect Password");
                    break;
                }
            }
            // If we made it here, then the password got rejected
            document.getElementById('appSettings_PwChgStatus').innerHTML = trans_dyn_content("Incorrect Password");
            break;
        
        default:
            break;
        }
        return;
    }
    
    function setRequeryRate(new_rate)
    {
        var strSql = '';
        // Update global flag
        global_SyncInterval = new_rate;
        // Update in local database
        strSql = 'UPDATE User_Info_DB SET sync_interval=' + new_rate + ' WHERE 1;';
        open_database_and_execute(strSql, '');
        return;
    }
    
    function setRemoteFeatures()
    {
        var strSql = '';
        var new_val = true;
        
        if (document.getElementById('appSettings_EnabRemote').checked) 
        {
            new_val = 1;
        }
        else
        {
            new_val = 0;
        }
        // Update global flag
        global_EnableRemoteAnalysis = new_val;
        // Dump the timestamp table to force reloading of everything
        g_LoadTimestamps = {};
        // Update in local database
        strSql = 'UPDATE User_Info_DB SET enable_remote_analysis=' + new_val + ' WHERE 1;';
        open_database_and_execute(strSql, '');
        return;
    }
    
    function changeTempUnits()
    {
        var new_val;
        var strSql_1;
        var strSql_2;
        if (document.getElementById('appSettings_tUnitsRadio_C').checked)
        {
            new_val = 'C';
            strSql_2 = 'UPDATE Data_Recs_DB SET temp=(temp-32)*5/9 WHERE temp>60;';
        }
        else
        {
            new_val = 'F';
            strSql_2 = 'UPDATE Data_Recs_DB SET temp=(temp*9/5)+32 WHERE temp<60;';
        }
        strSql_1 = 'UPDATE User_Info_DB SET t_units="' + new_val + '" WHERE 1;';
        open_database_and_execute(strSql_1, strSql_2);
    }
    function toggleCatholicMode()
    {
        if (global_catholic_mode)
        {
            // Disable "IVF" and "Insemination" events
            updateLocalDb_EventSettings(0, PASSED_INTEGER, 'ev_show_word2', 8, '', 0);
            updateLocalDb_EventSettings(0, PASSED_INTEGER, 'ev_show_word2', 4, '', 0);
        }
    }
    function toggleCatholicModeSetting()
    {
        global_catholic_mode = document.getElementById('appSettings_CathMode').checked;
        toggleCatholicMode();    
    }
    
    function AddPregnancy(state, param_1, param_2, pregDetails, new1_or_chg0)
    {
        var strSql = '';
        var tx = param_1;
        
        printDebug("State " + state + " of AddPregnancy");
        switch(state)
        {
        case 1:
            var pregDetails = {};
            var PregLen = 267;
            
            if (new1_or_chg0 != 0)
            {
                // New pregnancy
                var date_str = Date.parse(iOS_Date_Convert(document.getElementById('pregStartText').value) + ' 1:00:00');
                var preg_date = new Date(date_str);
                if (isNaN(preg_date))
                {
                    ShowPopupMessage(trans_dyn_content("The specified date is invalid.  Please enter a date in yyyy-mm-dd format and try again."), trans_dyn_content("Invalid Date"), '');
                    printDebug('Invalid date: ' + date_str);
                    break;
                }

                if (document.getElementById('DueDateMethRadio_Prem').checked)
                {
                    pregDetails['start'] = preg_date;
                    pregDetails['end'] = addDays(preg_date, PregLen);
                }
                else if (document.getElementById('DueDateMethRadio_Naegele').checked)
                {
                    pregDetails['start'] = addDays(preg_date, 14);
                    pregDetails['end'] = addDays(preg_date, PregLen-1);
                }
                else if (document.getElementById('DueDateMethRadio_Ov').checked)
                {
                    pregDetails['start'] = addDays(preg_date, 14);
                    pregDetails['end'] = addDays(preg_date, PregLen-1);
                }
                else if (document.getElementById('DueDateMethRadio_Manual').checked)
                {
                    var end_date_str = Date.parse(iOS_Date_Convert(document.getElementById('pregEndText').value) + ' 1:00:00');
                    var end_preg_date = new Date(end_date_str);
                    if (isNaN(end_preg_date))
                    {
                        ShowPopupMessage(trans_dyn_content("The specified end date is invalid.  Please enter a date in yyyy-mm-dd format and try again."), trans_dyn_content("Invalid Date"), '');
                        printDebug('Invalid date: ' + end_date_str);
                        break;
                    }
                    pregDetails['start'] = preg_date;
                    pregDetails['end'] = end_preg_date;
                }
                pregDetails['prevstart'] = DateToNumber(pregDetails['start']);
            }
            else
            {
                // Modify existing pregnancy
                var date_str = Date.parse(iOS_Date_Convert(document.getElementById('UpdatePregStartTextbox').value) + ' 1:00:00');
                var preg_date = new Date(date_str);
                var prior_preg_date;
                if (isNaN(preg_date))
                {
                    ShowPopupMessage(trans_dyn_content("The specified start date is invalid.  Please enter a date in yyyy-mm-dd format and try again."), trans_dyn_content("Invalid Date"), '');
                    printDebug('Invalid date: ' + date_str);
                    break;
                }
                date_str = Date.parse(iOS_Date_Convert(document.getElementById('UpdatePregEndTextbox').value) + ' 1:00:00');
                end_preg_date = new Date(date_str);
                if (isNaN(end_preg_date))
                {
                    ShowPopupMessage(trans_dyn_content("The specified end date is invalid.  Please enter a date in yyyy-mm-dd format and try again."), trans_dyn_content("Invalid Date"), '');
                    printDebug('Invalid date: ' + date_str);
                    break;
                }
                pregDetails['start'] = preg_date;
                pregDetails['prevstart'] = document.getElementById('EditPregPrevStart').innerHTML;
                pregDetails['end'] = end_preg_date;
                // Force reselection of charted cycle
                global_selected_cycle_as_number = 0;
            }
            pregDetails['start_val'] = DateToNumber(pregDetails['start']);
            pregDetails['end_val'] = DateToNumber(pregDetails['end']);
            
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_AddPreg_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_AddPreg_1 = -1;
                                    AddPregnancy(state+1, tx, '', pregDetails, new1_or_chg0);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_AddPreg_1 > 0)
                                    {
                                        global_db_ios_fail_AddPreg_1 = global_db_ios_fail_AddPreg_1 - 1;
                                        printDebug('iOS db.transaction failed AddPregnancy state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_AddPreg_1));
                                        AddPregnancy(state, param_1, param_2, pregDetails, new1_or_chg0);
                                    }
                                    else if (global_db_ios_fail_AddPreg_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:
            // Query values from local database. 
            strSql = 'SELECT * FROM Preg_DB ORDER BY preg_started ASC;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                AddPregnancy(state+1, tx, results, pregDetails, new1_or_chg0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 3:
            var results = param_2;
            var len = results.rows.length;
            var abort_case = false;
            var last_preg = -1;

            // Loop through results
            for (var i=0; i<len; i++)
            {
                var preg_start_val = results.rows.item(i)['preg_started'];
                var preg_end_val = preg_start_val + results.rows.item(i)['preg_len'] - 1;
printDebug('Found previous preg ' + PrintDate(NumberToDate(preg_start_val)) + ' to ' + PrintDate(NumberToDate(preg_end_val)));
printDebug(preg_start_val + '!=' + pregDetails['prevstart'] + ' with new1_or_chg0=' + new1_or_chg0);
                // Check overlap (exclude self if an update)
                if ((preg_start_val != pregDetails['prevstart']) || (new1_or_chg0 != 0))
                {
                    // Check for overlap
                    if (((preg_start_val >= pregDetails['start_val']) && (preg_start_val <= pregDetails['end_val'])) || ((preg_end_val >= pregDetails['start_val']) && (preg_end_val <= pregDetails['end_val'])))
                    {
                        // Conflict
                        ShowPopupMessage(trans_dyn_content("The new pregnancy cannot be recorded because it overlaps a previously recorded pregnancy. The conflicting pregnancy started on ") + PrintDate(NumberToDate(preg_start_val)) + trans_dyn_content(".  Remove it or use the Manual Due Date entry option to specify the pregnancy duration to avoid this overlap."), trans_dyn_content("Cannot Create Pregnancy"), '');
                        printDebug('Cannot add pregnancy due to conflict with preg');
                        abort_case = true;
                        break;
                    }
                }
                if ((preg_start_val < pregDetails['start_val']) && (results.rows.item(i)['preg_len'] > 0))
                {
                    last_preg = preg_start_val;
                }
            }
            if (abort_case == false)
            {
                pregDetails['last_preg'] = last_preg;
                // Query values from local database. 
                strSql = 'SELECT * FROM Cycles_DB ORDER BY cyc_started ASC;';
                suspend_scrolling(true, '');
                tx.executeSql(  strSql, 
                                [], 
                                function(tx, results) 
                                {
                                    suspend_scrolling(false, 0);
                                    AddPregnancy(state+1, tx, results, pregDetails, new1_or_chg0);
                                },
                                function(tx, err)
                                {
                                    crash_and_burn(err, 'Error querying local Cycles database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                }
                             );
            }
            break;

        case 4:
            var results = param_2;
            var len = results.rows.length;
            var potential_conflict = 0;
            var abort_case = false;
            var prior_cyc_val = -1;

            // Loop through results
            for (var i=0; i<len; i++)
            {
                var cyc_start_val = results.rows.item(i)['cyc_started'];
                var cyc_end_val = cyc_start_val + results.rows.item(i)['cyc_len'] - 1;
printDebug('Found previous cycle ' + PrintDate(NumberToDate(cyc_start_val)) + ' to ' + PrintDate(NumberToDate(cyc_end_val)));
                // Check for overlap
                if (((cyc_start_val >= pregDetails['start_val']) && (cyc_start_val <= pregDetails['end_val'])) || ((cyc_end_val >= pregDetails['start_val']) && (cyc_end_val <= pregDetails['end_val'])))
                {
                    if ((cyc_start_val <= pregDetails['start_val']) && (potential_conflict == 0))
                    {
                        potential_conflict = cyc_start_val;
                        printDebug('Exception for conception cycle ' + PrintDate(NumberToDate(cyc_start_val)) + ' to ' + PrintDate(NumberToDate(cyc_end_val)));
                    }
                    else
                    {
                        // Conflict
                        ShowPopupMessage(trans_dyn_content("The new pregnancy cannot be recorded because it overlaps a previously recorded cycle.  The conflicting cycle started on ") + PrintDate(NumberToDate(cyc_start_val)) + trans_dyn_content(".  Remove it or use the Manual Due Date entry option to specify the pregnancy duration to avoid this overlap."), 'Cannot Create Pregnancy', '');
                        printDebug('Cannot add pregnancy due to conflict with cycle');
                        abort_case = true;
                        break;
                    }
                }
                if (cyc_start_val < pregDetails['start_val'])
                {
                    prior_cyc_val = cyc_start_val;
                }
            }
            pregErrHelp = trans_dyn_content(" If you believe another cycle exists and is not being recognized (likely because it was not recorded in the app), load the chart for that cycle first to force app synchronization for that cycle and try again.");
            if (prior_cyc_val < 0)
            {
                // Conflict
                ShowPopupMessage(trans_dyn_content("Each pregnancy must have at least 1 cycle recorded before it starts.  The new pregnancy does not. Record the menstrual cycle prior to the start of this pregnancy and try again.") + pregErrHelp, trans_dyn_content("Cannot Create Pregnancy"), '');
                printDebug('Cannot add pregnancy due to absence of cycle');
                abort_case = true;
                break;
            }
            else
            {
                if ((pregDetails['last_preg'] >= prior_cyc_val) && ((new1_or_chg0 != 0) || (pregDetails['last_preg'] != document.getElementById('EditPregPrevStart').innerHTML))) // don't worry if changing this very cycle
                {
                    // Can't tie 2 pregs to same cycle
                    ShowPopupMessage(trans_dyn_content("Each pregnancy must have 1 unique cycle recorded before it starts. The cycle before this pregnancy already has another pregnancy recorded by it. Please record a new cycle between the pregnancies or delete the other pregnancy and try again.") + pregErrHelp, trans_dyn_content("Cannot Create Pregnancy"), '');
                    printDebug('Cannot add pregnancy due to absence of cycle');
                    abort_case = true;
                    break;
                }
                else if ((pregDetails['start_val'] - prior_cyc_val) >= 150)
                {
                    ShowPopupMessage(trans_dyn_content("Each pregnancy must have 1 unique cycle recorded within 150 days of its start. This pregnancy (") + PrintDateDivider(NumberToDate(pregDetails['start_val']),false) + trans_dyn_content(") has a cycle too long before it (") + PrintDateDivider(NumberToDate(prior_cyc_val),false) + trans_dyn_content(").  These dates are ") + (pregDetails['start_val'] - prior_cyc_val) + trans_dyn_content(" days apart.  Record a cycle that is less than 150 days prior to the pregnancy start and try again.") + pregErrHelp, trans_dyn_content("Cannot Create Pregnancy"), '');
                    printDebug('Cannot add pregnancy without recent cycle');
                    abort_case = true;
                    break;
                }
            }
            if (abort_case == false)
            {
                // Go ahead and record the pregnancy
                var strSql_fields;
                var strSql_values;
                var PregLen = pregDetails['end_val'] - pregDetails['start_val'] + 1;
                var execute = false;
                
                if (new1_or_chg0 != 0)
                {
                    strSql_fields = 'INSERT INTO Preg_DB (preg_started, ';
                    strSql_values = 'VALUES (' + pregDetails['start_val'] + ', ';
                    
                    strSql_fields += 'pdata_chg, pdata_pnd, ';
                    strSql_values += '7, 0, ';

                    strSql_fields += 'preg_len, preg_status) ';
                    strSql_values += PregLen + ', "preg");';
                    execute = true;
                }
                else
                {
                    var chg_bits = 0;
                    strSql_fields = 'UPDATE Preg_DB SET ';
                    strSql_values = '';
                    
                    myselect = $("select#Settings_PregOutcomeSelect");
                    var PregOutcome = ConvertPregOutcome(myselect[0].selectedIndex, true, false, false, false);
                    
                    // See what changed
                    if (pregDetails['start_val'] != document.getElementById('EditPregPrevStart').innerHTML)
                    {
                        strSql_values += 'preg_started=' + pregDetails['start_val'] + ', ';
                        chg_bits = chg_bits | Math.pow(2, dbPregDBField_PregStart.localDBEncodedBitIndex);
                    }
                    if (PregLen != document.getElementById('EditPregPrevLen').innerHTML)
                    {
                        strSql_values += 'preg_len=' + PregLen + ', ';
                        chg_bits = chg_bits | Math.pow(2, dbPregDBField_PregLen.localDBEncodedBitIndex);
                    }
                    if (PregOutcome != document.getElementById('EditPregPrevOutcome').innerHTML)
                    {
                        strSql_values += 'preg_status="' + PregOutcome + '", ';
                        chg_bits = chg_bits | Math.pow(2, dbPregDBField_PregStatus.localDBEncodedBitIndex);
                    }
                    if (chg_bits != 0)
                    {
                        strSql_values += 'pdata_chg=' + chg_bits + ' WHERE preg_started=' + document.getElementById('EditPregPrevStart').innerHTML + ';';
                        execute = true;
                    }
                }
                
                if (execute)
                {
                    strSql = strSql_fields + strSql_values;
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        AddPregnancy(state+1, tx, results, pregDetails, new1_or_chg0);
                                    },
                                    function(tx, err)
                                    {
                                        crash_and_burn(err, 'Error querying local Cycles database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                    }
                                 );
                 }
            }
            // Dump all load times to force everything to refresh
            g_LoadTimestamps = {};
            break;
        case 5:
            // Reload screen
            if (new1_or_chg0 == 0)
            {
                ShowPopupMessage(trans_dyn_content("This pregnancy has been updated."), trans_dyn_content("Success"), ''); 
            }
            else
            {
                ShowPopupMessage(trans_dyn_content("A new pregnancy was created."), trans_dyn_content("Success"), '');
            }
            reloadPregScreen();
            break;
        }
    }
    
    function reloadPregScreen()
    {
        // Force total resync
        g_LoadTimestamps = {};
        // Clear
        document.getElementById('chgPregDiv').style.display = 'none';
        document.getElementById('pregStartText').value = '';
        document.getElementById('pregEndText').value = '';
        // Reload
        var PREG_PAGE_INDEX = 4;  // global_Settings_Pages[4] = "settings_preg"
        navBetweenSettings(1, PREG_PAGE_INDEX, '', '');
    }    
    function userPickedPreg(state, param_1, param_2)
    {
        var strSql = '';
        var tx = param_1;
        
        printDebug("State " + state + " of userPickedPreg");
        switch(state)
        {
        case 1:
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_UserPickPreg_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_UserPickPreg_1 = -1;
                                    userPickedPreg(state+1, tx, '');
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_UserPickPreg_1 > 0)
                                    {
                                        global_db_ios_fail_UserPickPreg_1 = global_db_ios_fail_UserPickPreg_1 - 1;
                                        printDebug('iOS db.transaction failed userPickedPreg state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UserPickPreg_1));
                                        userPickedPreg(state, param_1, param_2);
                                    }
                                    else if (global_db_ios_fail_UserPickPreg_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:
            // Get selection
            var global_selected_preg_as_number = Number(document.getElementById('Settings_PregPickerSelect').value);
            
            // Query values from local database. 
            strSql = 'SELECT * FROM Preg_DB WHERE preg_started=' + global_selected_preg_as_number + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                userPickedPreg(state+1, tx, results);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 3:
            var results = param_2;
            var len = results.rows.length;

            if (len <= 0)
            {
                document.getElementById('chgPregDiv').style.display = 'none';
                ShowPopupMessage(trans_dyn_content("Could not find the selected pregnancy.  Please try resynchronizing by pressing the Sync button and try again."), trans_dyn_content("Could not edit pregnancy"), '');  
            }
            else
            {
                // Load results
                var i=0;
                var myselect;
                var pregStart = PrintDateDivider(NumberToDate(results.rows.item(i)['preg_started']),false);
                var pregEnd = PrintDateDivider(NumberToDate(results.rows.item(i)['preg_started'] + results.rows.item(i)['preg_len'] - 1),false);
                
                document.getElementById('EditPregPrevStart').innerHTML = results.rows.item(i)['preg_started'];
                document.getElementById('EditPregPrevLen').innerHTML = results.rows.item(i)['preg_len'];
                document.getElementById('EditPregPrevOutcome').innerHTML = results.rows.item(i)['preg_status'];
                
                document.getElementById('PregToEdit').innerHTML = pregStart;
                document.getElementById('UpdatePregStartTextbox').value = pregStart;
                document.getElementById('UpdatePregEndTextbox').value = pregEnd;
                myselect = $("select#Settings_PregOutcomeSelect");
                myselect[0].selectedIndex = ConvertPregOutcome(results.rows.item(i)['preg_status'], false, true, false, false);
                myselect.selectmenu("refresh");
                document.getElementById('chgPregDiv').style.display = 'block';
            }
            break;
        }
    }
    function DeletePreg()
    {
        var strSql = 'UPDATE Preg_DB SET preg_len=0,pdata_chg=' + Math.pow(2, dbPregDBField_PregLen.localDBEncodedBitIndex) + ' WHERE preg_started=' + document.getElementById('EditPregPrevStart').innerHTML + ';';
printDebug(strSql + '  ' + PrintDate(NumberToDate(document.getElementById('EditPregPrevStart').innerHTML)));
        open_database_and_execute(strSql, ''); 
        ShowPopupMessage(trans_dyn_content("Pregnancy was deleted."), trans_dyn_content("Success"), '');
        reloadPregScreen();
        // Force reselection of charted cycle
        global_selected_cycle_as_number = 0;
        // Dump all load times to force everything to refresh
        g_LoadTimestamps = {};
    }

    function addDays(date, days) 
    {
        var result = new Date(date);
        result.setDate(date.getDate() + days);
        return result;
    }
    function ConvertPregOutcome(inputData, index2db, db2index, db2show, show2db)
    {
        var retval = 'ERROR91731';
        var mapping = {};
        var db_PREG_field = 'preg';
        var db_MIS_field = 'miscar';
        var db_BIRTH_field = 'birth';
        var show_PREG_text = 'Still Pregnant';
        var show_MIS_text = 'Miscarriage';
        var show_BIRTH_text = 'Gave Birth';

        if (index2db)
        {
            mapping[0] = db_PREG_field;
            mapping[1] = db_MIS_field;
            mapping[2] = db_BIRTH_field;
            retval = mapping[inputData];
        }
        else if (db2index)
        {
            mapping[db_PREG_field] = 0;
            mapping[db_MIS_field] = 1;
            mapping[db_BIRTH_field] = 2;
            retval = mapping[inputData];
        }
        else if (db2show)
        {
            mapping[db_PREG_field] = show_PREG_text;
            mapping[db_MIS_field] = show_MIS_text;
            mapping[db_BIRTH_field] = show_BIRTH_text;
            retval = mapping[inputData];
        }
        else if (show2db)
        {
            mapping[show_PREG_text] = db_PREG_field;
            mapping[show_MIS_text] = db_MIS_field;
            mapping[show_BIRTH_text] = db_BIRTH_field;
            retval = mapping[inputData];
        }
        else
        {
            printDebug('Error - hit ELSE in ConvertPregOutcome');
        }
        return retval;
    }
    function savePregMsg(showit)
    {
        if (showit)
        {
            document.getElementById("ChgWarnDiv").style.color = "yellow";
        }
        else
        {
            document.getElementById("ChgWarnDiv").style.color = "white";
        }
    }
    
    function UpdateDBGroups(new1_or_chg0, grp0_or_contact1)
    {
        var gCodeStr;
        var ctrlName;
        var ctrlTarg;
        var descStr;
        var sel_group;
        
        if (new1_or_chg0 == 0)
        {
            ctrlName = 'Update';
        }
        else
        {
            ctrlName = 'New';
        }
        if (grp0_or_contact1 == 0)
        {
            ctrlTarg = 'GroupCode';
            sel_group = Number(document.getElementById('Settings_GroupsSelect').value);
        }
        else
        {
            ctrlTarg = 'Contact';
            sel_group = Number(document.getElementById('Settings_ContactSelect').value);
        }
        gCodeStr = document.getElementById(ctrlName + ctrlTarg + 'Textbox').value.toLowerCase();
        gCodeStr = gCodeStr.replace(/\s+/g, ''); // remove spaces
        if ((gCodeStr.charAt(0) == '#') && (gCodeStr.length > 1))
        {
            gCodeStr = gCodeStr.substring(1,gCodeStr.length-1); 
        }
        if (grp0_or_contact1 == 1)
        {
            gCodeStr = '@' + gCodeStr;
        }
        descStr = document.getElementById(ctrlName + ctrlTarg + 'DescTextbox').value;
        
        // Validate inputs
        if (gCodeStr == '')
        {
            ShowPopupMessage(trans_dyn_content("You must specify a group code."), trans_dyn_content("Could not save group"), '');
        }
        else if ((gCodeStr.indexOf('@') >= 0) && (grp0_or_contact1 == 0))
        {
            ShowPopupMessage(trans_dyn_content("You cannot use the @ symbol in your group code."), trans_dyn_content("Could not save group"), '');
        }
        else
        {
            // Call state machine
            DefineMsgGroup(1, '', new1_or_chg0, grp0_or_contact1, gCodeStr, descStr, sel_group, true);
        }
    }
    
    function DefineMsgGroup(state, param_1, new1_or_chg0, grp0_or_contact1, gCodeStr, descStr, sel_group, grpscrn)
    {
        var strSql = '';
        var tx = param_1;
        printDebug("State " + state + " of DefineMsgGroup");
        switch(state)
        {
        case 1:
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_DefGroup_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_DefGroup_1 = -1;
                                    DefineMsgGroup(state+1, tx, new1_or_chg0, grp0_or_contact1, gCodeStr, descStr, sel_group, grpscrn);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_DefGroup_1 > 0)
                                    {
                                        global_db_ios_fail_DefGroup_1 = global_db_ios_fail_DefGroup_1 - 1;
                                        printDebug('iOS db.transaction failed DefineMsgGroup state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_DefGroup_1));
                                        DefineMsgGroup(state, param_1, new1_or_chg0, grp0_or_contact1, gCodeStr, descStr, sel_group, grpscrn);
                                    }
                                    else if (global_db_ios_fail_DefGroup_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:       
            // Delete any previous record 
            var sql_byID = '';
            if (new1_or_chg0 == 0)
            {
                sql_byID = " OR id=" + sel_group;
            }
            
            strSql = "DELETE FROM Groups_DB WHERE gcode='" + gCodeStr + "'" + sql_byID + ";";
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                DefineMsgGroup(state+1, tx, new1_or_chg0, grp0_or_contact1, gCodeStr, descStr, sel_group, grpscrn);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;

        case 3:
            // Insert
            strSql = "INSERT INTO Groups_DB (gcode, desc) VALUES ('" + ReplaceQuotes(gCodeStr) + "', '" + ReplaceQuotes(descStr) + "');";
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                DefineMsgGroup(state+1, tx, new1_or_chg0, grp0_or_contact1, gCodeStr, descStr, sel_group, grpscrn);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;

        case 4:
            // Reload screen
            if (grpscrn)
            {
                ShowPopupMessage(trans_dyn_content("This group has been saved."), trans_dyn_content("Success"), '');
                reloadGroupScreen();
            }
            break;
        }
    }
    function reloadGroupScreen()
    {
        // Clear
        document.getElementById('NewGroupCodeTextbox').value = '';
        document.getElementById('NewGroupCodeDescTextbox').value = '';
        document.getElementById('UpdateGroupCodeTextbox').value = '';
        document.getElementById('UpdateGroupCodeDescTextbox').value = '';
        document.getElementById('chgGroupDiv').style.display = 'none';
        document.getElementById('NewContactTextbox').value = '';
        document.getElementById('NewContactDescTextbox').value = '';
        document.getElementById('UpdateContactTextbox').value = '';
        document.getElementById('UpdateContactDescTextbox').value = '';
        document.getElementById('chgContactDiv').style.display = 'none';
        // Reload
        navBetweenSettings(1, 5, '', '');
    }
    function userPickedGroup(state, grp0_or_contact1, param_1, param_2)
    {
        var strSql = '';
        var tx = param_1;
        
        printDebug("State " + state + " of userPickedGroup");
        switch(state)
        {
        case 1:
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_UserPickGroup_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_UserPickGroup_1 = -1;
                                    userPickedGroup(state+1, grp0_or_contact1, tx, '');
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_UserPickGroup_1 > 0)
                                    {
                                        global_db_ios_fail_UserPickGroup_1 = global_db_ios_fail_UserPickGroup_1 - 1;
                                        printDebug('iOS db.transaction failed userPickedGroup state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UserPickGroup_1));
                                        userPickedGroup(state, grp0_or_contact1, param_1, param_2);
                                    }
                                    else if (global_db_ios_fail_UserPickGroup_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:
            // Get selection
            var sel_group;
            if (grp0_or_contact1 == 0)
            {
                sel_group = Number(document.getElementById('Settings_GroupsSelect').value);
            }
            else
            {
                sel_group = Number(document.getElementById('Settings_ContactSelect').value);
            }

            // Query values from local database. 
            strSql = 'SELECT * FROM Groups_DB WHERE id=' + sel_group + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                userPickedGroup(state+1, grp0_or_contact1, tx, results);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 3:
            var results = param_2;
            var len = results.rows.length;

            if (len <= 0)
            {
                if (grp0_or_contact1 == 0)
                {
                    document.getElementById('chgGroupDiv').style.display = 'none';
                }
                else
                {
                    document.getElementById('chgContactDiv').style.display = 'none';
                }
                ShowPopupMessage(trans_dyn_content("Could not find the selected group."), trans_dyn_content("Error"), '');  
            }
            else
            {
                // Load results
                var myselect;
                var i = 0;
                var gCode = results.rows.item(i)['gcode'];
                if (grp0_or_contact1 == 0)
                {
                    document.getElementById('UpdateGroupCodeTextbox').value = '#' + gCode;
                    document.getElementById('UpdateGroupCodeDescTextbox').value = results.rows.item(i)['desc'];
                    document.getElementById('GroupToEdit').innerHTML = gCode;
                    document.getElementById('chgGroupDiv').style.display = 'block';
                }
                else
                {
                    if (gCode.charAt(0) == '@')
                    {
                        gCode = gCode.substring(1,gCode.length);
                    }
                    document.getElementById('UpdateContactTextbox').value = gCode;
                    document.getElementById('UpdateContactDescTextbox').value = results.rows.item(i)['desc'];
                    document.getElementById('ContactToEdit').innerHTML = gCode;
                    document.getElementById('chgContactDiv').style.display = 'block';
                }
            }
            break;
        }
    }
    function DeleteGroup(grp0_or_contact1)
    {
        var sel_group;
        var targetStr;
        if (grp0_or_contact1 == 0)
        {
            sel_group = Number(document.getElementById('Settings_GroupsSelect').value);
            targetStr = "Group";
        }
        else
        {
            sel_group = Number(document.getElementById('Settings_ContactSelect').value);
            targetStr = "Contact";
        }
        strSql = "DELETE FROM Groups_DB WHERE id='" + sel_group + "';";
        open_database_and_execute(strSql, ''); 
        ShowPopupMessage(targetStr + trans_dyn_content(" was deleted."), trans_dyn_content("Success"), '');
        reloadGroupScreen();
    }
    function iOS_Date_Convert(date_str)
    {
        var retval;
        if (global_is_ios)
        {
            retval = ReplaceAllOccurrences(date_str, '-', '/');
        }
        else
        {
            retval = date_str;
        }
        return retval;
    }
    function savePushSettings(ctrl_id, ctrl_type, upfield, validate)
    {
        var do_upload = false;
        var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
        
        switch(ctrl_type)
        {
        case 'cbox':
            if (document.getElementById(ctrl_id).checked)
            {
                uploadParameters['upval']=1;
            }
            else
            {
                uploadParameters['upval']=0;
            }
            uploadParameters['upfield']=upfield;
            do_upload = true;
            break;
        case 'txt':
            if (validate == 'time')
            {
            
            }
            uploadParameters['upval']=document.getElementById(ctrl_id).value;
            uploadParameters['upfield']=upfield;
            do_upload = true;
            break;
        }
    
        // Upload Push Notification Settings
        if (do_upload)
        {
            var url_str = global_server_prefix + 'apps_set_data.aspx?t=' + getLocalTime();
            
            // Validate the password with the online version.  Specify values to upload
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['push_cfg'] = '1';
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;

            // Use jQuery to post data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) {
                    // Handles response this function and advance to the next state.  Notice that the tx
                    // cannot be passed to this legitimately because it is not being created as a call
                    // to this registered function (it only has a newContent argument) because this 
                    // callback has nothing to do with databases.  Therefore we will have to re-establish
                    // the tx variable when we want to resume database operations.
                    printDebug('Success: Saved ' + uploadParameters['upfield'] + '=' + uploadParameters['upval']);
                },
                dataType: 'html'
            });
        }
    }
    function changeInstrWatch(new_setting, student_uid, cmdDiv)
    {
        var url_str = global_server_prefix + 'apps_set_data.aspx?t=' + getLocalTime();
        var do_upload = false;
        var uploadParameters = {};
        
        if (gPushRegID == '')
        {
            ShowPopupMessage('This app has not received a push ID from the operating system. Make sure push notifications are turned on for this app and try again.', 'Push Notifications', '');
            // DEBUG: Uncomment to allow even without a push ID (be careful not to release this way!)
            return;
        }
        
        // New setting
        uploadParameters['push_watch'] = '1';
        uploadParameters['stud_uid']=student_uid;
        uploadParameters['stud_watch']=new_setting;
        uploadParameters['push_rid'] = gPushRegID;

        // Validate the password with the online version.  Specify values to upload
        uploadParameters['un'] = global_username;
        uploadParameters['pw'] = global_password;
        uploadParameters['app_ver'] = global_app_ver_str;
        uploadParameters['device_id'] = global_device_id_str;

        // Use jQuery to post data to the server
        $.ajax({
            type: 'POST',
            // The URL of the request
            url: url_str,
            // Values to upload
            data: uploadParameters,
            // The success callback with result from server
            success: function(newContent) {
                // Handles response this function and advance to the next state.  Notice that the tx
                // cannot be passed to this legitimately because it is not being created as a call
                // to this registered function (it only has a newContent argument) because this 
                // callback has nothing to do with databases.  Therefore we will have to re-establish
                // the tx variable when we want to resume database operations.
                printDebug('Success: Saved ' + uploadParameters['upfield'] + '=' + uploadParameters['upval']);
            },
            dataType: 'html'
        });
        
        // Flop text
        if (new_setting == 0)
        {
            document.getElementById(cmdDiv).innerHTML = '<a href="#" onclick="javascript:changeInstrWatch(1, ' + student_uid + ', \'' + cmdDiv + '\');" style="color:#232323;"><img src="images/addwatch.png"><br>' + trans_dyn_content("Begin watching<br>this student's<br>phase changes") + '</a>';
        }
        else
        {
            document.getElementById(cmdDiv).innerHTML = '<a href="#" onclick="javascript:changeInstrWatch(0, ' + student_uid + ', \'' + cmdDiv + '\');" style="color:#232323;"><img src="images/delwatch.png"><br>' + trans_dyn_content("Stop watching<br>this student's<br>phase changes") + '</a>';
        }
    }
	function updateBkgndColorSetting(global_selected_date)
	{
		// Update setting
		global_dark_bkgnd = document.getElementById('appSettings_DarkBkgnd').value;
		updateLocalDb_UserInfo('appSettings_DarkBkgnd', OPTIONS_LIST, 'dark_bkgnd')                    

		// Determine dynamic background
		var new_color = '#FFFFFF';
		var currDate = new Date();
		var currHour = currDate.getHours();
		if (global_dark_bkgnd > 0)
		{
			if ((global_dark_bkgnd == DARK_ALWAYS) || (currHour < 8))
			{
				new_color = '#000000';
			}
		}
		// Change Color
		var cols = document.getElementsByClassName('BkgdStyle');
		for(i=0; i<cols.length; i++) 
		{
		  cols[i].style.backgroundColor = new_color;
		}
	}
    