
// File for code that must execute after jQuery is loaded, but before jQuery Mobile is loaded.
// (e.g. things requiring the "mobileinit" event).
//

var CURRENT_APP_VERSION = '5.2.0';

var global_app_ver_str = 'pre-init ' + CURRENT_APP_VERSION;
var global_device_id_str = 'pre-init ' + CURRENT_APP_VERSION;
var global_calculated_scale;
var gPushRegID = '';
var gPushDetMsg = '';
var gPushDetTit = '';
var gPushDetLnk = '';

// Disable page transitions because they cause annoying transition problems on Android.
//
// http://jquerymobile.com/test/docs/api/globalconfig.html   
$(document).bind("mobileinit", function()
                               {
                                    // Fixes iOS9 bug
                                    $.mobile.hashListeningEnabled = false;
//                                    var iOS_device = false;
//                                    if ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)))
//                                    {
//                                        iOS_device = true;
//                                    }
//                                    else if (navigator.userAgent.match(/like Mac OS X/i)) 
//                                    {
//                                        iOS_device = true;
//                                    }
//                                    if (iOS_device == false)
//                                    {
//                                        $.mobile.defaultPageTransition = "none"; 
//                                        $.mobile.defaultDialogTransition = "none";
//                                    }
                                    var tempStr = navigator.userAgent.toLowerCase();
                                    var android_device = tempStr.indexOf("android") > -1;
                                    // Only hide this on Android devices
                                    if (android_device == true)
                                    {
                                       // Enabling this eliminates jerky behavior, but then the "fixed" header/footers 
                                       // don't work.  "fade" also fixes jerky behavior.  Waiting for jQuery Mobile v 1.1
                                       $.mobile.defaultPageTransition = "none"; 
                                       $.mobile.defaultDialogTransition = "none";
                                    }
                               }
            
                );
                
                
function onDeviceReady()
{
LogCall('1b');
printDebug('onDeviceReady running');

    // Register other callbacks now that PhoneGap is fully loaded
    // Reference: http://docs.phonegap.com/en/1.0.0/phonegap_events_events.md.html
    printDebug('Registering other callbacks');
    document.addEventListener("backbutton", AndroidBackButtonPush, true);
    document.addEventListener("menubutton", AndroidMenuButtonPush, true);
    document.addEventListener("offline", setOffline, false);
    document.addEventListener("online", setOnline, false);
    
    // Setup push notifications
    var pushNotification = window.plugins.pushNotification;
    if ( isIOS() )
    {
		var push = PushNotification.init({ "android": {}, "ios": {"alert": "true", "badge": "false", "sound": "true"}, "windows": {} });
		push.on('registration', function(data) {iOSPushTokenHandler(data)});
		push.on('notification', function(data) {onNotificationAPN(data)});
		push.on('error', function(e) { printDebug('GCM error = ' + e.message); });

		StatusBar.hide();
    }
    else if (isKindleFire()) 
    {
        // Amazon
        pushNotification.register(pushSuccessHdlr, pushErrorHdlr,{"senderID":gAmazonSenderID,"ecb":"onNotificationADM"});
    }
    else
    {
        // Android
        var push = PushNotification.init({ "android": {"senderID": gAndroidSenderID}, "ios": {}, "windows": {} } );
        push.on('registration', function(data) {onNotificationGCM_register(data)});
        push.on('notification', function(data) {onNotificationGCM_notify(data)});
        push.on('error', function(e) { printDebug('GCM error = ' + e.message); });
    }
    
    // Get device information - For some reason it isn't available until a second or
    // so after the onDeviceReady function runs, so I set a timeout to get it later.
    setTimeout("getDeviceInfo();",1500);
	
	// Load the correct app screen to start the app
	startup_app_navigation();
}
function getDeviceInfo()
{
    printDebug('getting device information');
    if ((window.device === undefined) || (window.device === null))
    {
        printDebug('window.device does not exist'); // Forgot to install Cordova plugin?
        if (isIOS())
        {
            global_device_id_str = 'iOS: ';
        }
    }
    else
    {
        if (BUILD_TARGET == BUILD_4_DOSP)
        {
            global_app_ver_str = window.device.version + ' / ' + window.device.phonegap + ' /DOSP ' + CURRENT_APP_VERSION + ' w' + $('body').width();
        }
        else
        {
            global_app_ver_str = window.device.version + ' / ' + window.device.phonegap + ' / ' + CURRENT_APP_VERSION + ' w' + $('body').width();
        }
        global_device_id_str = window.device.platform + ': ' + window.device.model + ' (' + window.device.uuid + ')';
    }
}
function isIOS()
{
    var iOS_device = false;
    if ((navigator.userAgent.match(/iPhone/i)) || (navigator.userAgent.match(/iPod/i)))
    {
        iOS_device = true;
    }
    else if (navigator.userAgent.match(/like Mac OS X/i)) 
    {
        iOS_device = true;
    }
    return iOS_device;
}
function isAndroid()
{
    var tempStr = navigator.userAgent.toLowerCase();
    var android_device = tempStr.indexOf("android") > -1;
    return android_device;
}
function isKindleFire()
{
    var tempStr = navigator.userAgent.toLowerCase();
    var android_device = tempStr.indexOf("fire") > -1;
    return android_device;
}

// Update DOM on a Received Event 
function pushReceivedEvent(id) 
{
    //var parentElement = document.getElementById(id); 
    //var listeningElement = parentElement.querySelector('.listening'); 
    //var receivedElement = parentElement.querySelector('.received'); 

    //listeningElement.setAttribute('style', 'display:none;'); 
    //receivedElement.setAttribute('style', 'display:block;'); 

    //alert('Received Event: ' + id); 
}
// result contains any message sent from the plugin call 
function pushSuccessHdlr(result) 
{ 
    printDebug('Push Callback Success! Result='+result) 
}
function pushErrorHdlr(error) 
{ 
    printDebug('Push Callback Failed!');
}
iOSPushErrorHandler = function(e)
{
    printDebug('Push Callback Failed!');
}
iOSPushTokenHandler = function(data)
{
	printDebug('iOSPushTokenHandler');
    if ( data.registrationId.length > 0 ) 
    {
        gPushRegID = data.registrationId;
        printDebug("Push Reg ID=" + data.registrationId);
    } 
}
iOSPushSuccess = function(e)
{
    printDebug('Push Callback Success!');
}
onNotificationAPN = function (data)
{ 
printDebug('[---@@@@@@@@@@@@');
printDebug('onNotificationAPN called');
	//printDebug(JSON.stringify(data));
    reactToPush(data.additionalData.mtype, true, data.message);
printDebug('onNotificationAPN exiting');
printDebug('@@@@@@@@@@@@---]');
} 

onNotificationADM = function(e)
{
    printDebug('onNotificationADM called');
    // Amazon acts like Google
    onNotificationGCM(e);
}

onNotificationGCM_register = function(data)
{
    if ( data.registrationId.length > 0 ) 
    {
        gPushRegID = data.registrationId;
        printDebug("Push Reg ID=" + data.registrationId);
    } 
}
onNotificationGCM_notify = function(data)
{
	var pos;
	var msg = data.message;
	var msgType = -1;
	
    // Push notification: msgcnt for GSM only.  e.foreground, e.coldstart
    printDebug('message = ' + msg + ' msgcnt = ' + data.count );
	
	pos = msg.indexOf(":");
	if (pos > 0) 
	{
		msgType = msg.substring(0,pos);
		msg = msg.substring(pos+1,msg.length);
	}

    reactToPush(msgType, data.additionalData.foreground, data.message);  
}

function reactToPush(msgType, foreground, message)
{
printDebug('reactToPush');
    const PUSH_ID_MSG_RESPOND_TO_ME = 101;
    const PUSH_ID_MSG_RESPOND_CONVERSATION = 102;
    const PUSH_ID_MSG_PRIVATE = 103;
    const PUSH_ID_ALARM_TIME = 201;
    const PUSH_ID_ALARM_REMIND = 202;
    const PUSH_ID_NEW_CYCLE = 300;
    const PUSH_ID_PHASE_CHG = 301;
    const PUSH_ID_TTC_PEAK_FERTILITY = 302;
    const PUSH_ID_OVDATES = 303;
	const PUSH_ID_UNKNOWN = -1;
    
    switch( Number(msgType) ) 
    {
		case PUSH_ID_UNKNOWN: 
			GiveDetailsOnPush('Attention: ' + message, 'Notification', '',1);
			break;
        case PUSH_ID_MSG_PRIVATE:
            var funcToCall = 'TransitionToSubscreen("comm_inbox","none")';
            GiveDetailsOnPush('Attention: ' + message, 'New Private Message', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>View My Inbox</a><br>',1);
            break;
        case PUSH_ID_MSG_RESPOND_CONVERSATION:
        case PUSH_ID_MSG_RESPOND_TO_ME:
            var funcToCall = 'TransitionToSubscreen("comm_board","none")';
            GiveDetailsOnPush('Attention: ' + message, 'Message Board Response', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>View Message Boards</a><br>',1);
            break;
        case PUSH_ID_ALARM_TIME:
        case PUSH_ID_ALARM_REMIND:
            var notified = false;
            var funcToCall = '';
            var suppress_link = true;
            if (global_curr_page == 'calendar')
            {
                var todays_date = new Date();
                var calendar_index = DateToNumber(todays_date) - global_calendar_start_int + 1;
                if ((calendar_index > 0) && (calendar_index <= 42))
                {
                    funcToCall = 'jump_to_calendar_date(1, ' + calendar_index + ')';
                    GiveDetailsOnPush('Attention: ' + message, 'New Reminder', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>Record Symptoms Now</a><br>',1);
                    notified = true;
                }
            }
            else if (global_curr_page == global_Calendar_Pages[0])
            {
                var todays_date = new Date();
                var calendar_index = (DateToNumber(todays_date) - global_calendar_start_int + 1);
                if ((calendar_index > 0) && (calendar_index <= 42))
                {
                    var direction = calendar_index - global_calendar_index;
                    if (direction != 0)
                    {
                        funcToCall = 'swipeGeneral_CalendarSubscreen(' + direction + ')';
                        GiveDetailsOnPush('Attention: ' + message, 'New Reminder', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>Record Symptoms Now</a><br>',1);
                        notified = true;
                    }
                }
            }
            else
            {
                suppress_link = false;
            }
            if (notified == false)
            {
                if (suppress_link)
                {
                   GiveDetailsOnPush('Attention: ' + message, 'New Reminder', '',1);
                }
                else
                {
                    funcToCall = 'navToMainCalendar(1)';
                    GiveDetailsOnPush('Attention: ' + message, 'New Reminder', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>View calendar to record symptoms</a><br>',1); 
                }
            }
            break;
        case PUSH_ID_NEW_CYCLE:
            var funcToCall = 'NavigateDirectToPicker()';
            GiveDetailsOnPush('Attention: ' + message, 'New Cycle', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>Select Cycle Now</a><br>',1);
            break;
        case PUSH_ID_TTC_PEAK_FERTILITY:
            var funcToCall = 'NavigateToAnalysisSubscreen("' + global_Analysis_Pages[0] + '");';
            GiveDetailsOnPush('Attention: ' + message, 'Trying to Conceive', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>View Chart Now</a><br>',1);
            break;
        case PUSH_ID_PHASE_CHG:
            var funcToCall = 'NavigateToAnalysisSubscreen("' + global_Analysis_Pages[2] + '");';
            GiveDetailsOnPush('Attention: ' + message, 'Phase Transitions', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>Select Phase Dates Now</a><br>',1);
            break;
        case PUSH_ID_OVDATES:
            var funcToCall = 'NavigateToAnalysisSubscreen("' + global_Analysis_Pages[2] + '");';
            GiveDetailsOnPush('Attention: ' + message, 'Ovulation Dates', '<a href=\'#\' onclick=\'javascript:' + funcToCall + ';\'>View Ovulation Dates</a><br>',1);
            break;
        default:
            printDebug('WARNING reactToPush in default ' + msgType);
    }        
}
